proc (1) =em(th,y);
   local  rv,cc,p,pxp,pxa,pkim,qkim,q,zed1,zed2,y1,y2,term1s1,term1a,term1s2,
	term2s1, term2s2, term2a,p11,p22,b1,b2,sigma1,pcr,qcr,rho, 
      addterm,numer1,pth,qth, gradz, cmprsn, fitzzz,t,thetanew,gradien, v, 
	numer,thetaold,qxa,qxp, top,test1,test2,nobs,oldval,
	startime, endtime;

startime=date;
thetanew =th;
nobs=rows(y);

cmprsn=1;
rv=0;
do until cmprsn< _emconvg; 
@ or whatever other value you like@
	rv=rv+1;
	if rv > _emmaxit;
		"Max EM iteration limit reached";
		retp(thetanew);
	endif;

	if _emprint;
		"EM: Iteration";;rv;
	endif;

	{pkim,pxa,pxp,fitzzz,p,q}=emsmth(thetanew,y);
 
	qkim=ones(rows(y),1)-pkim;
	qxp=ones(rows(y),1)-pxp;
	qxa=ones(rows(y),1)-pxa;

	@Equation 22.4.16 @  
	pcr=0;
	qcr=0;
	if iy == 0;             rho = (1-meanc(q))/(2-meanc(p)-meanc(q));
	 	elseif iy == 1;         rho = cdfn(th[sumc(vei)+2+ix,1]);
	 	elseif iy == 2;         rho = 1.0;
	  	elseif iy == 3;         rho = 0;
	endif;
	pcr= p[1,1]*(pkim[1,1]*rho)./pxa[1,1];
	qcr= q[1,1]*((1-pkim[1,1])*(1-rho))./(1-pxa[1,1]);

/*
if minc(minc(pkim~pxp~pxa))==0;
"bad things going to happen";
rv=-999;
retp(rv);
endif;
*/

	top=(pkim[2:nobs,.].*pxp[1:nobs-1,1])./pxa[2:nobs,1];
	top=sumc(top);
	p= ln(p)+ln(top+pcr)-ln(rho+sumc(pkim[1:nobs-1,.]));
	p=exp(p);

/*
if minc(minc(qkim~qxp~qxa))==0;
"bad things going to happen";
rv=-999;
retp(rv);
endif;
*/

/*
top=ln(qkim[2:nobs,.])+ln(qxp[1:nobs-1,1])-ln(qxa[2:nobs,1]);
top=sumc(exp(top));
*/

	top=sumc(qkim[2:nobs,.].*qxp[1:nobs-1,1]./qxa[2:nobs,1]);
	q= ln(q)+ln(top+qcr)-ln(1-rho+sumc(qkim[1:nobs-1,.]));
	q=exp(q);

	p11=p[1,1];
	p22=q[1,1];

	if iscplx(pkim)==1;
		"pkim iscomplex";
		rv=-88;
		retp(rv);
	endif;

	oldval=trapchk(1);
	trap 1,1;

	@Equation 22.4.23 and 22.4.22 @
	b1 = (y[.,1].*sqrt(pkim)) / (y[.,terms[1,1]:terms[1,2]].*sqrt(pkim));
	trap oldval,1;

	if scalerr(b1);
		"danger";
		retp(rv);
	endif;

	if (iscplx(qkim)==1) or minc(qkim)<0;
		"qkim is complex or <0";
		rv=-88;
		retp(rv);
	endif;
	b2 = (y[.,1].*sqrt(qkim)) / (y[.,terms[2,1]:terms[2,2]].*sqrt(qkim));

@Equation 22.4.21 @

	if ix==0;
		sigma1 = exp(ln((y[.,1]-y[.,terms[1,1]:terms[1,2]]*b1)^2)+ln(pkim)) + exp(ln((y[.,1]-y[.,terms[2,1]:terms[2,2]]*b2)^2)+ln(qkim));
		sigma1=sumc(sigma1)./rows(y);
	elseif ix==1;
		sigma1=(y[.,1]-y[.,terms[1,1]:terms[1,2]]*b1)^2;
/*
if minc(sigma1)==0;
retp(rv);
endif;
if minc(pkim)==0;
retp(rv);
endif;
*/
		sigma1=(sigma1.*pkim)~(((y[.,1]-y[.,terms[2,1]:terms[2,2]]*b2)^2).*qkim);
		sigma1=sumc(sigma1);
		sigma1[1]=sigma1[1]/sumc(pkim);
		sigma1[2]=sigma1[2]/sumc(qkim);
	endif;

@to get the std. devation@
	sigma1=sqrt(sigma1);

	thetaold=thetanew;
	if p11<0;
		p11;
		p11=0;
	endif;

	if p22<0;
		p22;
		p22=0;
	endif;

	if p11>1;
		p11;
		p11=1;
	endif;

	if p22>1;
		p22;
		p22=1;
	endif;

	{p11}=cdfni(p11);
	{p22}=cdfni(p22);

	thetanew = b1|b2|p11|p22|sigma1;
	cmprsn=sumc(abs(thetanew-thetaold));
	if _emprint;
		thetanew';
	endif;
endo;

if __output>0;
	endtime=date;
	"EM converged after ";; rv;; "Iterations of a possible";; _emmaxit;
	" Total time: ";;   etstr(ethsec(startime,endtime));;
	"   Average time: ";; etstr(ethsec(startime,endtime)/rv);
endif;



retp(thetanew);
endp;
